
package de.ivu.elect.presentation.person.table;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Named;

import de.ivu.elect.business.person.entity.Beruf;
import de.ivu.elect.jee.presentation.dynamictable.AbstractColumnBuilder;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;

@Named(BerufColumnBuilder.COMPONENT_NAME)
public class BerufColumnBuilder extends AbstractColumnBuilder<Beruf> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "berufColumnBuilder";

  private AbstractBerufColumn<Beruf> berufNameColumn;

  private AbstractBerufColumn<Beruf> berufCodeColumn;

  private AbstractBerufColumn<Beruf> berufHerkunftColumn;

  private AbstractBerufColumn<Beruf> berufGeschlechtColumn;

  public BerufColumnBuilder() {
    super();
  }

  @Override
  protected void initColumns() {
    berufNameColumn = AbstractBerufColumn.createBerufNameColumn(getMessages());
    berufCodeColumn = AbstractBerufColumn.createBerufCodeColumn(getMessages());
    berufHerkunftColumn = AbstractBerufColumn.createBerufHerkunftColumn(getMessages());
    berufGeschlechtColumn = AbstractBerufColumn.createBerufGeschlechtColumn(getMessages());
  }

  @Override
  protected List<ColumnEntry< ? super Beruf>> getColumnEntriesSorted() {
    List<ColumnEntry< ? super Beruf>> result = new ArrayList<>();

    result.add(berufNameColumn);
    result.add(berufCodeColumn);
    result.add(berufHerkunftColumn);
    result.add(berufGeschlechtColumn);

    return result;
  }
}
